<template>
  <div class="page">
    <LayoutTable :data="tableData" :config="tableConfig">
      <el-button
        slot="table-head-left2"
        style="margin-left: 10px"
        icon="el-icon-tickets"
        size="mini"
        @click="handleImport"
        >导入</el-button
      >
      <el-button
        slot="table-head-left2"
        style="margin-left: 10px"
        icon="el-icon-tickets"
        size="mini"
        @click="doExport"
        :disabled="isExport"
        >导出</el-button
      >
    </LayoutTable>

    <!-- 设备管理导入对话框 -->
    <el-dialog
      :title="upload.title"
      :visible.sync="upload.open"
      width="400px"
      append-to-body
    >
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url + '?updateSupport=' + upload.updateSupport"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          将文件拖到此处，或
          <em>点击上传</em>
        </div>
        <div class="el-upload__tip" slot="tip">
          <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的数据
          <el-link
            type="primary"
            style="font-size: 14px"
            @click="downloadTemplate"
            >下载模板</el-link
          >
        </div>
        <div class="el-upload__tip" style="color: red" slot="tip">
          提示：仅允许导入“xls”或“xlsx”格式文件！
        </div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>

    <drawer-show ref="drawerform" @ok="getData" />
  </div>
</template>

<script>
/** 表单弹出框模式需引入 */
import drawerShow from "./drawershow";
import table from "@/assets/mixins/table";
export default {
  name: "DeviceList",
  components: {
    drawerShow,
  },
  mixins: [table],
  created() {
    console.log("route", this.$route);
    this.changePath("/device");
    this.query = Object.assign({}, this.query, { productCode: "dzmp" });
  },
  methods: {
    /** 导入 */
    handleImport() {
      this.upload.title = "设备管理导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    downloadTemplate() {
      this.isExport = true;
      this.$download("/device/downloadTemplate", {}, { type: "excel" })
        .then(() => (this.isExport = false))
        .catch((error) => {
          this.isExport = false;
          this.$message.error(error.message);
        });
    },
    /** 文件上传中处理 */
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    /** 文件上传成功处理 */
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
      this.getData();
    },
    /** 提交上传文件 */
    submitFileForm() {
      this.$refs.upload.submit();
    },
    /** 导出Excel */
    doExport() {
      this.isExport = true;
      this.$download(
        "/device/exportExcel",
        {
          idList: this.selection,
        },
        { type: "excel" }
      )
        .then(() => (this.isExport = false))
        .catch((error) => {
          this.isExport = false;
          this.$message.error(error.message);
        });
    },
    /** 重写新增方法 */
    toAdd(row) {
      this.$refs.drawerform.add(row);
    },
    /** 重写编辑方法 */
    toEdit(row) {
      this.$refs.drawerform.edit(row);
    },
    /** 重写查看方法 */
    toView(row) {
      this.$refs.drawerform.view(row);
    },

    activeDevice(row) {
      this.$post("/device/active", {
        deviceCode: row.deviceCode,
      })
        .then((res) => {
          if (res.code == 1) {
            this.$message.success("激活设备成功！");
            this.getData();
          }
        })
        .catch((error) => {
          this.$message.error(error.message);
        });
    },
    // 操作菜单状态
    changeStatus(row, column) {
      return (
        <device-switch
          confirm
          url="/device/enable"
          row={row}
          onChange={this.statusChange}
          value={this.tableData.data}
          onInput={(data) => {
            this.tableData.data = data;
          }}
        />
      );
    },
    statusChange() {
      this.$store.dispatch("login");
    },
  },
  data() {
    return {
      // 用户导入参数
      upload: {
        // 是否显示弹出层（设备管理导入）
        open: false,
        // 弹出层标题（设备管理导入）
        title: "导入设备管理数据",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的数据
        updateSupport: 0,
        // 上传的地址
        url: "/office/device/importData",
      },
      isExport: false,
      config: {
        search: [
          {
            name: "deviceName",
            type: "text",
            label: "设备名称",
            fuzzy: true,
          },
        ],
        columns: [
          { type: "selection", width: 60 },
          { type: "index", label: "序号", width: 50 },

          {
            label: "设备名称",
            prop: "deviceName",
            formatter: (row) => (row.deviceName ? row.deviceName : "--"),
          },

          { label: "所属房间", prop: "roomId", formatter: this.formatter },

          {
            label: "设备编码",
            prop: "deviceCode",
            formatter: (row) => (row.deviceCode ? row.deviceCode : "--"),
          },

          {
            label: "MAC地址",
            prop: "deviceMac",
            formatter: (row) => (row.deviceMac ? row.deviceMac : "--"),
          },

          {
            label: "设备位置",
            prop: "deviceAddr",
            formatter: (row) => (row.deviceAddr ? row.deviceAddr : "--"),
          },

          {
            label: "联系电话",
            prop: "leadingOfficialTelephone",
            formatter: (row) =>
              row.leadingOfficialTelephone
                ? row.leadingOfficialTelephone
                : "--",
          },

          {
            label: "设备状态 ",
            prop: "deviceStatus",
            formatter: this.formatter,
          },

          {
            prop: "enabled",
            align: "center",
            label: "启用/停用",
            width: 100,
            formatter: this.changeStatus,
          },

          {
            label: "操作",
            width: 240,
            formatter: (row) => {
              return (
                <div>
                  <span> </span>
                  {row.deviceStatus === 0 ? (
                    <el-button
                      size="mini"
                      type="text"
                      icon="el-icon-open"
                      onClick={() => {
                        this.activeDevice(row);
                      }}
                    >
                      激活
                    </el-button>
                  ) : (
                    ""
                  )}
                  <span> </span>
                  <table-buttons
                    noAdd
                    row={row}
                    onEdit={this.toEdit}
                    onView={this.toView}
                    onDel={this.toDel}
                  />
                </div>
              );
            },
          },
        ],
      },
    };
  },
};
</script>
